<?php
/** 
*
* Module Breizh ajax checks
* @version $Id: ajaxchecks.php 110 13:17 23/04/2011 Sylver35 Exp $ 
* @copyright (c) 2010, 2011 Breizh Portal  http://breizh-portal.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_user.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

// Check that the $_GET['mode'] variable has been set
if (!isset($_GET['mode']))
{
	exit('');
}

// Set the variables
$mode 		= request_var('mode', '');
$username 	= utf8_normalize_nfc(request_var('username', '', true));
$password1 	= utf8_normalize_nfc(request_var('password1', '', true));
$password2 	= utf8_normalize_nfc(request_var('password2', '', true));
$email1 	= strtolower(utf8_normalize_nfc(request_var('email1', '', true)));
$email2 	= strtolower(utf8_normalize_nfc(request_var('email2', '', true)));

// Automatic change language (¦-)
$use_lang = request_var('lang', $user->lang_name);
$user->lang_name = $use_lang;
$user->lang = array();
$user->data['user_lang'] = $user->lang_name;

// The inclusion of language files must be here for the swappable language
$user->add_lang(array('common', 'ucp', 'mods/ajaxchecks'));

$go = $mode. '|';
$_tpl_no = '&nbsp;<span style="color: #FF0000;">';
$_tpl_ok = '&nbsp;<span style="color: #008000;">';
$_tpl_end = '</span>';

switch ($mode)
{
	case 'usernamecheck':
		// Check that the username given has not already been used
		// Verifie the length - utf8 compatibility
		// if username is too small
		if (utf8_strlen(htmlspecialchars_decode($username)) < $config['min_name_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_SHORT_USERNAME') . $_tpl_no . $user->lang['TOO_SHORT_USERNAME'] . $_tpl_end);
		}
		// if username is too long
		elseif (utf8_strlen(htmlspecialchars_decode($username)) > $config['max_name_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_LONG_USERNAME') . $_tpl_no . $user->lang['TOO_LONG_USERNAME'] . $_tpl_end);
		}
		
		$checkresult = validate_username($username);
		
		// Check if it the username is ok (false means it is)
		// if username doesn't exist and respect the obligations
		if ($checkresult === false)
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_USERNAME_TRUE') . $_tpl_ok . $user->lang['AJAX_CHECK_USERNAME_TRUE'] . $_tpl_end;
		}
		// if the username already exists or does not respect the obligations
		else
		{
			$return = $go . $user->img('icon_ajax_false', $checkresult . '_USERNAME') . $_tpl_no . $user->lang[$checkresult . '_USERNAME'] . $_tpl_end;
		}
		
		// Stop execution and show the result
		exit($return);
	break;

	case 'usernamecur':
		// Check that the username given has not already been used
		// Verifie the length - utf8 compatibility
		// if username is too small
		if (utf8_strlen(htmlspecialchars_decode($username)) < $config['min_name_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_SHORT_USERNAME') . $_tpl_no . $user->lang['TOO_SHORT_USERNAME'] . $_tpl_end);
		}
		// if username is too long
		elseif (utf8_strlen(htmlspecialchars_decode($username)) > $config['max_name_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_LONG_USERNAME') . $_tpl_no . $user->lang['TOO_LONG_USERNAME'] . $_tpl_end);
		}
		
		$checkresult = validate_username($username);
		
		// Check if it the username is ok (false means it is)
		// if username doesn't exist and respect the obligations
		if ($checkresult === false)
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_USERNAME_TRUE') . $_tpl_ok . $user->lang['AJAX_CHECK_USERNAME_TRUE'] . $_tpl_end;
		}
		// if the username already exists or does not respect the obligations
		else
		{
			exit($go . $user->img('icon_ajax_false', $checkresult . '_USERNAME') . $_tpl_no . $user->lang[$checkresult . '_USERNAME'] . $_tpl_end);
		}
		
		// it's actual username?
		if ($username == $user->data['username'])
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_USERNAME_CUR') . $_tpl_ok . $user->lang['AJAX_CHECK_USERNAME_CUR'] . $_tpl_end;
		}
		
		// Stop execution and show the result
		exit($return);
	break;

	case 'passwordcheck':
		// Check that the two passwords given are the same
		// Verifie the length - utf8 compatibility
		// if password is too small
		if (utf8_strlen(htmlspecialchars_decode($password1)) < $config['min_pass_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_SHORT_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_SHORT_NEW_PASSWORD'] . $_tpl_end);
		}
		// if password is too long
		elseif (utf8_strlen(htmlspecialchars_decode($password1)) > $config['max_pass_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_LONG_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_LONG_NEW_PASSWORD'] . $_tpl_end);
		}
		// if password is too small
		if (utf8_strlen(htmlspecialchars_decode($password2)) < $config['min_pass_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_SHORT_PASSWORD_CONFIRM') . $_tpl_no . $user->lang['TOO_SHORT_PASSWORD_CONFIRM'] . $_tpl_end);
		}
		// if password is too long
		elseif (utf8_strlen(htmlspecialchars_decode($password2)) > $config['max_pass_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_LONG_PASSWORD_CONFIRM') . $_tpl_no . $user->lang['TOO_LONG_PASSWORD_CONFIRM'] . $_tpl_end);
		}
		
		// Check the password doesn't contain any illegal chars, etc.
		$checkresult = validate_password($password1);
		
		// Check if it the password is ok (false means it is)
		if ($checkresult === false)
		{
			// Check the passwords are the same
			if ($password1 == $password2)
			{
				// Passwords are the same, show a correct message
				$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_PASSWORD_TRUE') . $_tpl_ok . $user->lang['AJAX_CHECK_PASSWORD_TRUE'] . $_tpl_end;
				
				// Why not actually do the check now that we've got the function done :-)
				$strength = check_password_strength($password1);
				$return = $return . '<br /><br />' . $user->img('icon_ajax_strength_' . $strength, 'AJAX_CHECK_PASSWORD_STRENGTH') . '&nbsp;' . $user->lang['AJAX_CHECK_PASSWORD_STRENGTH_' . $strength];
			}
			else
			{
				// Passwords not the same, show the error
				$return = $go . $user->img('icon_ajax_false', 'AJAX_CHECK_PASSWORD_FALSE') . $_tpl_no . $user->lang['AJAX_CHECK_PASSWORD_FALSE'] . $_tpl_end;
			}
		}
		else
		{
			// Failed the password validation
			$error_lang = (!isset($user->lang[$checkresult . '_NEW_PASSWORD'])) ? $checkresult : $user->lang[$checkresult . '_NEW_PASSWORD'];
			$return = $go . $user->img('icon_ajax_false', $error_lang) . $_tpl_no . $error_lang . $_tpl_end;
		}
		
		// Stop execution and show the result
		exit($return);
	break;

	case 'emailcheck';
		// Check that the two email addresses given are the same
		// Verifie the length
		// if email is too small
		if (utf8_strlen(htmlspecialchars_decode($email1)) < 10)
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_SHORT_EMAIL') . $_tpl_no . $user->lang['TOO_SHORT_EMAIL'] . $_tpl_end);
		}
		
		// Check the email is not in use, has the correct format, is for a "real" domain, etc.
		$checkresult = validate_email($email1);
		
		// Check if it the email is ok (false means it is)
		if ($checkresult !== false)
		{
			// Failed the email validation
			$raison = sprintf($user->lang['AJAX_CHECK_INVALID_EMAIL'], ((!isset($user->lang[$checkresult. '_EMAIL'])) ? utf8_normalize_nfc($checkresult) : $user->lang[$checkresult. '_EMAIL']));
			$return = $go . $user->img('icon_ajax_false', 'AJAX_CHECK_EMAIL_FAIL') . '&nbsp;' . $raison;
		}
		else
		{
			// Now check both are the same
			if ($email1 == $email2)
			{
				$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_EMAIL_TRUE') . $_tpl_ok . $user->lang['AJAX_CHECK_EMAIL_TRUE'] . $_tpl_end;
			}
			else
			{
				$return = $go . $user->img('icon_ajax_false', 'AJAX_CHECK_EMAIL_FALSE') . $_tpl_no . $user->lang['AJAX_CHECK_EMAIL_FALSE'] . $_tpl_end;
			}
		}
		
		// Stop execution and show the result
		exit($return);
	break;

	case 'checkemail':
		// Check that the two email addresses given are the same
		// Verifie the length
		// if email is too small
		if (utf8_strlen(htmlspecialchars_decode($email1)) < 10)
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_SHORT_EMAIL') . $_tpl_no . $user->lang['TOO_SHORT_EMAIL'] . $_tpl_end);
		}
		
		// Check the email is not in use, has the correct format, is for a "real" domain, etc.
		$checkresult = validate_email($email1);
		
		// Check if it the email is ok (false means it is)
		if ($checkresult !== false)
		{
			// Failed the email validation
			$raison = sprintf($user->lang['AJAX_CHECK_INVALID_EMAIL'], ((!isset($user->lang[$checkresult. '_EMAIL'])) ? utf8_normalize_nfc($checkresult) : $user->lang[$checkresult. '_EMAIL']));
			$return = $go . $user->img('icon_ajax_false', 'AJAX_CHECK_EMAIL_FAIL') . '&nbsp;' . $raison;
		}
		else
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_EMAIL_TRUE_FIRST') . $_tpl_ok . $user->lang['AJAX_CHECK_EMAIL_TRUE_FIRST'] . $_tpl_end;
		}
		
		// Stop execution and show the result
		exit($return);
	break;

	case 'passwordcur':

		$check_password = phpbb_check_hash($password1, $user->data['user_password']);
		
		if ($check_password !== false)
		{
			$return = $go . $user->img('icon_ajax_false', 'SAME_PASSWORD_ERROR') . $_tpl_no . $user->lang['SAME_PASSWORD_ERROR'] . $_tpl_end;
		}
		else
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_PASSWORD_OK') . $_tpl_ok . $user->lang['AJAX_CHECK_PASSWORD_OK'] . $_tpl_end;
		}

		// Verifie the length - utf8 compatibility
		// if password is too small
		if (utf8_strlen(htmlspecialchars_decode($password1)) < $config['min_pass_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_SHORT_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_SHORT_NEW_PASSWORD'] . $_tpl_end);
		}
		// if password is too long
		elseif (utf8_strlen(htmlspecialchars_decode($password1)) > $config['max_pass_chars'])
		{
			exit($go . $user->img('icon_ajax_false', 'TOO_LONG_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_LONG_NEW_PASSWORD'] . $_tpl_end);
		}
		
		// Check the password doesn't contain any illegal chars, etc.
		$checkresult = validate_password($password1);
		
		// Check if it the password is ok (false means it is)
		if ($checkresult !== false)
		{
			// Failed the password validation
			$error_lang = (!isset($user->lang[$checkresult . '_NEW_PASSWORD'])) ? $checkresult : $user->lang[$checkresult . '_NEW_PASSWORD'];
			$return = $go . $user->img('icon_ajax_false', $error_lang) . $_tpl_no . $error_lang . $_tpl_end;
		}
		
		// Stop execution and show the result
		exit($return);
	break;

	case 'oldpassword':
		
		$check_password = phpbb_check_hash($password1, $user->data['user_password']);
		
		if ($check_password !== false)
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_PASSWORD_OK') . $_tpl_ok . $user->lang['AJAX_CHECK_PASSWORD_OK'] . $_tpl_end;
		}
		else
		{
			exit($go . $user->img('icon_ajax_false', 'CUR_PASSWORD_ERROR') . $_tpl_no . $user->lang['CUR_PASSWORD_ERROR'] . $_tpl_end);
		}
		
		// Now check both are the same
		if ($password1 == $password2)
		{
			$return = $go . $user->img('icon_ajax_false', 'SAME_PASSWORD_ERROR') . $_tpl_no . $user->lang['SAME_PASSWORD_ERROR'] . $_tpl_end;
		}
		
		// Stop execution and show the result
		exit($return);
	break;
	
	default:
		// Dunno what we are doing so return
		exit('');
	break;
}

// Now, check the "strength" of the password and show an image accordingly
function check_password_strength($password)
{
	$strength = 0;
	$patterns = array('#[a-z]#','#[A-Z]#','#[0-9]#','/[¬!"£$%^&*()`{}\[\]:@~;\'#<>?,.\/\\-=_+\|]/');
	foreach($patterns as $pattern)
	{
		if (preg_match($pattern, $password, $matches))
		{
			$strength++;
		}
	}
	
	if (strlen($password) < 7 && $strength > 1)
	{
		// If the length is less than 7 maximum can be rating can be 2
		$strength = 1;
	}
	elseif (strlen($password) < 9 && $strength > 2)
	{
		// If the length is less than 9 maximum can be rating can be 2
		$strength = 2;
	}
	elseif (strlen($password) >= 10 && $strength != 4)
	{
		// If the length is 10 or more then give it one higher rating (unless 4 already)
		$strength++;
	}
	return $strength;
}

?>